# Compile combined.c with all possible permutations of the extensions
# it uses and see how many different output programs are produced.

import os, sys, pprint

def permute(lst):
    if len(lst) == 0:
        yield []
        return
    for rest in permute(lst[1:]):
        for p in range(len(lst)):
            yield rest[:p] + [lst[0]] + rest[p:]

groups = {}

for exts in permute(["xlambda", "xalef-iter", "xaif", "xpcre"]):
    args = ["../../zcc", "-lpcre"]
    for ext in exts:
        args.extend(["-x", ext])
    args.append("combined.c")
    if os.spawnv(os.P_WAIT, args[0], args) != 0:
        sys.exit(1)
    output = file("/tmp/a.out.c").read()
    groups.setdefault(output, []).append(exts)

pprint.pprint(groups.values())
