struct Compile
{
	Compile(Typecheck *tc) :
		tc_(tc),
		codebuf_(nil),
		tailcall_(0),
		fn_(nil),
		tmpstack_(nil) {}
	
	Typecheck *tc_;
	Codebuf *codebuf_;
	int tailcall_;
	Fn *fn_;
	Arena arena_;
	List<int> *tmpstack_;
	
	Loc *mktmp(Type *type);
	Loc *localloc(int mode, Type *type);  // mode is LocGlobal etc.
	void pushtmp();
	void poptmp();
	void leaexpr(Expr*, Loc*);

	Loc *evaltmp(Expr*);
	Loc *evalint(Line, int);
	Loc *evalfloat(Line, double);
	Loc *evalinto(Expr*, Loc*);
	Loc *evalexpr(Expr*, Loc*, Loc*);

	Loc *offset(Loc*, int);
	Loc *deref(Line, Loc*);
	
	void emitp(void*);
	void emiti(int);
	void emitf(double);
	void emitline(Line);
	void emitC(Line, Code*);
	void emitloc(Loc*);
	void emitCP(Line, Code*, void*);
	void emitCL(Line, Code*, Loc*);
	void emitCLI(Line, Code*, Loc*, int);
	void emitCLF(Line, Code*, Loc*, double);
	void emitCLP(Line, Code*, Loc*, void*);
	void emitCLL(Line, Code*, Loc*, Loc*);
	void emitCLLP(Line, Code*, Loc*, Loc*, void*);
	void emitCLPL(Line, Code*, Loc*, void*, Loc*);
	void emitCLLPP(Line, Code*, Loc*, Loc*, void*, void*);
	void emitCPLL(Line, Code*, void*, Loc*, Loc*);
	void emitCLLL(Line, Code*, Loc*, Loc*, Loc*);
	void emitCPLLL(Line, Code*, void*, Loc*, Loc*, Loc*);
	void emitCLLLL(Line, Code*, Loc*, Loc*, Loc*, Loc*);
	void emitCLLLP(Line, Code*, Loc*, Loc*, Loc*, void*);
	void emitCLPLL(Line, Code*, Loc*, void*, Loc*, Loc*);
	void emitjmp(Line, Code*, Loc*, Label*);
	void emitlabel(Label*);
	void emitloadptr(Line, Loc*, void*);
	void emitloadint(Line, Loc*, int);
	void emitloadfloat(Line, Loc*, double);
	void emitmov(Line, Loc*, Loc*);
	void emitloadfn(Line, Loc*, Fn*);

private:
	void ensure(int);
};
