#include "u.h"
#include "arena.h"
#include "emalloc.h"

void
pusharena(Arena **ap)
{
	Arena *a;
	
	a = (Arena*)emalloc(sizeof *a);
	a->next = *ap;
	*ap = a;
}

Arena*
poparena(Arena **ap)
{
	Arena *a;

	if(*ap == nil)
		return (Arena*)nil;
	a = *ap;
	*ap = a->next;
	return a;
}

void*
amalloc(Arena  *a, int n)
{
	char *p;
	ArenaChunk *c;

	if(a == nil)
		return emalloc(n);
	n = (n+7)&~7;
	if(n > a->n){
		a->n = ((n+4095) & ~4095) - sizeof(ArenaChunk);
		c = (ArenaChunk*)emalloc(sizeof(ArenaChunk) + a->n);
		a->p = (char*)(c+1);
		c->next = a->chunks;
		a->chunks = c;
	}
	p = a->p;
	a->p += n;
	a->n -= n;
	return p;
}

void
aclear(Arena *a)
{
	ArenaChunk *c, *next;

	if(a == nil)
		return;
	for(c=a->chunks; c; c=next){
		next = c->next;
		free(c);
	}
	a->chunks = (ArenaChunk*)nil;
	a->p = (char*)nil;
	a->n = 0;
}

void
afree(Arena *a)
{
	aclear(a);
	free(a);
}

