// Arena-based allocator.  Arenas can be nested.

typedef struct Arena Arena;
typedef struct ArenaChunk ArenaChunk;

struct Arena
{
	Arena *next;
	ArenaChunk *chunks;
	Arena *child;
	Arena *nextsib;
	Arena *prevsib;
	char *p;
	int n;
	
	Arena() :
		next(nil),
		chunks(nil),
		child(nil),
		nextsib(nil),
		prevsib(nil),
		p(nil),
		n(0) {}
};

struct ArenaChunk
{
	ArenaChunk *next;
};

// Push a new arena onto the arena stack.
void pusharena(Arena **ap);

// Pop an arena off the arena stack, returning it.
Arena *poparena(Arena **ap);

// Allocate n bytes from the arena a.
void *amalloc(Arena *a, int n);

// Free all the allocations in the arena a,
// but not its children and not its parents.
// Arena must have been popped already.
// Frees a too.
void afree(Arena *a);

// Free everything afree does, except a itself.
// (For statically declared arenas.)
void aclear(Arena *a);

