template<typename K, typename V> struct Hash;

Hash<void*,void*> *_mkhash(void);
Hash<void*,void*> *_mkhasha(Arena*);
void *_hashput(Hash<void*,void*>*, void*, void*);
void *_hashget(Hash<void*,void*>*, void*);

List<void*> *_hashkeys(Hash<void*,void*>*);
List<void*> *_hashvalues(Hash<void*,void*>*);

/* Iterators */

template<typename K, typename V>
struct Hashkv
{
	K key;
	V value;
};

template<typename K, typename V>
struct Hashiter
{
	int i, j;
	Hash<K,V> *h;
};

int _hashiterstart(Hashiter<void*,void*>*, Hash<void*,void*>*);
int _hashiternextkey(Hashiter<void*,void*>*, void**);
int _hashiternextkv(Hashiter<void*,void*>*, Hashkv<void*,void*>*);
void _hashiterend(Hashiter<void*,void*>*);


template<typename K, typename V>
Hash<K,V>*
mkhash()
{
	static_assert(sizeof(K) == sizeof(void*));
	static_assert(sizeof(V) == sizeof(void*));
	return (Hash<K,V>*)_mkhash();
}

template<typename K, typename V>
Hash<K,V>*
mkhasha(Arena *a)
{
	return (Hash<K,V>*)_mkhasha(a);
}

template<typename K, typename V>
V
hashput(Hash<K,V> *h, K k, V v)
{
	static_assert(sizeof(K) == sizeof(void*));
	static_assert(sizeof(V) == sizeof(void*));
	void *vv = _hashput((Hash<void*,void*>*)h, *(void**)&k, *(void**)&v);
	return *(V*)&vv;
}

template<typename K, typename V>
V
hashget(Hash<K,V> *h, K k)
{
	static_assert(sizeof(K) == sizeof(void*));
	static_assert(sizeof(V) == sizeof(void*));
	void *v = _hashget((Hash<void*,void*>*)h, *(void**)&k);
	return *(V*)&v;
}

template<typename K, typename V>
List<K>*
hashkeys(Hash<K,V> *h)
{
	return (List<K>*)_hashkeys((Hash<void*,void*>*)h);
}

template<typename K, typename V>
List<V>*
hashvalues(Hash<K,V> *h)
{
	return (List<V>*)_hashvalues((Hash<void*,void*>*)h);
}

template<typename K, typename V>
int
hashiterstart(Hashiter<K,V> *it, Hash<K,V> *h)
{
	return _hashiterstart((Hashiter<void*,void*>*)it, (Hash<void*,void*>*)h);
}

template<typename K, typename V>
int
hashiternextkey(Hashiter<K,V> *it, K *k)
{
	return _hashiternextkey((Hashiter<void*,void*>*)it, (void**)k);
}
template<typename K, typename V>
int
hashiternextkv(Hashiter<K,V> *it, Hashkv<K,V> *kv)
{
	return _hashiternextkv((Hashiter<void*,void*>*)it, (Hashkv<void*,void*>*)kv);
}

template<typename K, typename V>
void
hashiterend(Hashiter<K,V> *it)
{
	_hashiterend((Hashiter<void*,void*>*)it);;
}


int _hashiterstart(Hashiter<void*,void*>*, Hash<void*,void*>*);
int _hashiternextkey(Hashiter<void*,void*>*, void**);
int _hashiternextkv(Hashiter<void*,void*>*, Hashkv<void*,void*>*);
void _hashiterend(Hashiter<void*,void*>*);


