#include "u.h"
#include "utf.h"
#include "fmt.h"
#include "name.h"
#include "arena.h"
#include "emalloc.h"
#include "list2.h"
#include "cfg.h"
#include "slr.h"
#include "bitset.h"

void
slrdumptables(CfgGram<void> *g)
{
	int i, j, k, first;
	CfgRule<void> *r;
	SlrState *z;
	CfgSym<void> *s;
	
	print("\n================================\n");

	for(i=0; i<g->nsym; i++){
		s = g->sym[i];
		print("%s:%s\n", s->name, 
			(s->flags&CfgSymEmpty) ? " canempty" : "");
		print("\tfirst:");
		for(j=0; j<g->nsym; j++)
			if(inbitset(s->first, g->sym[j]->n))
				print(" %s", g->sym[j]->name);
		print("\n");
		print("\tfollow:");
		for(j=0; j<g->nsym; j++)
			if(inbitset(s->follow, g->sym[j]->n))
				print(" %s", g->sym[j]->name);
		print("\n");
	}
	print("\n");

/*	compileall(g); */
	for(i=0; i<g->nslrstate; i++){
		z = g->slrstate[i];
		print("#state %d: %d shift, %d reduce, %d pos\n",
			z->n, z->nshift, z->nreduce, z->npos);
		print("%d: %lY\n", i, z);
		for(j=0; j<z->nshift; j++){
			print("\t%s: shift %d\n", z->shift[j].sym ? (char*)z->shift[j].sym->name : "<>", z->shift[j].slrstate ? z->shift[j].slrstate->n : -1);
		}
		for(j=0; j<z->nreduce; j++){
			r = z->reduce[j];
			print("\t");
			first = 1;
			for(k=0; k<g->nsym; k++){
				if(inbitset(r->left->follow, k)){
					if(first)
						first = 0;
					else
						print(" ");
					print("%s", g->sym[k]->name);
				}
			}
			print(": reduce %R\n", r);
		}
	}
}

